#pragma once

// OcvitaBarcodeCtrl.h : Declaration of the COcvitaBarcodeCtrl ActiveX Control class.


// COcvitaBarcodeCtrl : See OcvitaBarcodeCtrl.cpp for implementation.

class COcvitaBarcodeCtrl : public COleControl
{
	DECLARE_DYNCREATE(COcvitaBarcodeCtrl)

// Constructor
public:
	COcvitaBarcodeCtrl();

// Overrides
public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();

	virtual	DWORD GetControlFlags();

// Implementation
protected:
	~COcvitaBarcodeCtrl();

	DECLARE_OLECREATE_EX(COcvitaBarcodeCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(COcvitaBarcodeCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(COcvitaBarcodeCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(COcvitaBarcodeCtrl)		// Type name and misc status

// Message maps
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
		dispidsetting_1 = 26,
		dispidcode_page = 25,
		dispidrotate_angle = 24,
		dispidprimary = 23,
		dispidbitmap_height = 22,
		dispidbitmap_width = 21,
		dispidget_bitmap = 20L,
		dispiderrtxt = 19,
		dispidget_row_height = 18L,
		dispidget_encoded_data = 17L,
		dispidwidth = 16,
		dispidrows = 15,
		dispidhrtext = 14,
		dispidinput_mode = 13,
		dispidscale = 12,
		dispidoption_3 = 11,
		dispidoption_2 = 10,
		dispidoption_1 = 9,
		dispidbgcolour = 8,
		dispidfgcolour = 7,
		dispidoutput_options = 6,
		dispidborder_width = 5,
		dispidwhitespace_width = 4,
		dispidheight = 3,
		dispidbarcode = 2,
		dispidsymbology = 1
	};

// custom variables
	struct zint_symbol *symbol;

protected:
	long symbology, height, whitespace_width, border_width, output_options;
	long option_1, option_2, option_3, input_mode, rotate_angle; 
	
	long code_page, setting_1; 

	float scale;

	CString barcode, fgcolour, bgcolour, outfile, primary, hrtext;

protected:
	LONG Getsymbology(void);
	void Setsymbology(LONG newVal);
	BSTR Getbarcode(void);
	void Setbarcode(LPCTSTR newVal);
	LONG Getheight(void);
	void Setheight(LONG newVal);
	LONG Getwhitespace_width(void);
	void Setwhitespace_width(LONG newVal);
	LONG Getborder_width(void);
	void Setborder_width(LONG newVal);
	LONG Getoutput_options(void);
	void Setoutput_options(LONG newVal);
	BSTR Getfgcolour(void);
	void Setfgcolour(LPCTSTR newVal);
	BSTR Getbgcolour(void);
	void Setbgcolour(LPCTSTR newVal);
	LONG Getoption_1(void);
	void Setoption_1(LONG newVal);
	LONG Getoption_2(void);
	void Setoption_2(LONG newVal);
	LONG Getoption_3(void);
	void Setoption_3(LONG newVal);
	FLOAT Getscale(void);
	void Setscale(FLOAT newVal);
	LONG Getinput_mode(void);
	void Setinput_mode(LONG newVal);
	BSTR Gethrtext(void);
	void Sethrtext(LPCTSTR newVal);
	LONG Getrows(void);
	void Setrows(LONG newVal);
	LONG Getwidth(void);
	void Setwidth(LONG newVal);
	BYTE get_encoded_data(LONG x, LONG y);
	LONG get_row_height(LONG row);
	BSTR Geterrtxt(void);
	void Seterrtxt(LPCTSTR newVal);
	CHAR get_bitmap(LONG index);
	LONG Getbitmap_width(void);
	void Setbitmap_width(LONG newVal);
	LONG Getbitmap_height(void);
	void Setbitmap_height(LONG newVal);
	BSTR Getprimary(void);
	void Setprimary(LPCTSTR newVal);
	LONG Getrotate_angle(void);
	void Setrotate_angle(LONG newVal);
	LONG Getcode_page(void);
	void Setcode_page(LONG newVal);
	LONG Getsetting_1(void);
	void Setsetting_1(LONG newVal);
};

